package danielcortes.xyz.models.efectivo;

import danielcortes.xyz.models.caja.Caja;
import java.util.List;
import java.util.Optional;

public interface EfectivoDAO {

  /**
   * Obtiene todos los Efectivo
   *
   * @return Una lista con los Efectivo
   */
  List<Efectivo> getAll();

  /**
   * Obtiene un Efectivo por su id
   *
   * @param id Id del Efectivo
   * @return Un Optional que puede contener un Efectivo o puede estar vacio
   */
  Optional<Efectivo> getById(int id);

  /**
   * Obtiene un Efectivo por su Caja
   *
   * @param caja Caja a la que pertence el Efectivo
   * @return Un Optional que puede contener un Efectivo o puede estar vacio
   */
  Optional<Efectivo> getByCaja(Caja caja);

  /**
   * Obtiene la suma de los valores de los Efectivo pertencientes a una Caja
   *
   * @param caja Caja a la que pertenecen los Efectivo a sumar
   * @return La suma de los valores de Efectivo
   */
  int getTotalEfectivo(Caja caja);

  /**
   * Guarda un Efectivo, le agrega un id a la instancia
   *
   * @param efectivo Efectivo a guardar
   */
  void insert(Efectivo efectivo);

  /**
   * Actualiza un Efectivo
   *
   * @param efectivo Efectivo a guardar
   */
  void update(Efectivo efectivo);

  /**
   * Elimina un Efectivo
   *
   * @param efectivo Efectivo a eliminar
   */
  void delete(Efectivo efectivo);
}
